// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go_gapic. DO NOT EDIT.

package fleetengine_test

import (
	"context"

	fleetengine "cloud.google.com/go/maps/fleetengine/apiv1"
	fleetenginepb "cloud.google.com/go/maps/fleetengine/apiv1/fleetenginepb"
	"google.golang.org/api/iterator"
)

func ExampleNewTripClient() {
	ctx := context.Background()
	// This snippet has been automatically generated and should be regarded as a code template only.
	// It will require modifications to work:
	// - It may require correct/in-range values for request initialization.
	// - It may require specifying regional endpoints when creating the service client as shown in:
	//   https://pkg.go.dev/cloud.google.com/go#hdr-Client_Options
	c, err := fleetengine.NewTripClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	// TODO: Use client.
	_ = c
}

func ExampleTripClient_CreateTrip() {
	ctx := context.Background()
	// This snippet has been automatically generated and should be regarded as a code template only.
	// It will require modifications to work:
	// - It may require correct/in-range values for request initialization.
	// - It may require specifying regional endpoints when creating the service client as shown in:
	//   https://pkg.go.dev/cloud.google.com/go#hdr-Client_Options
	c, err := fleetengine.NewTripClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &fleetenginepb.CreateTripRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/cloud.google.com/go/maps/fleetengine/apiv1/fleetenginepb#CreateTripRequest.
	}
	resp, err := c.CreateTrip(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleTripClient_GetTrip() {
	ctx := context.Background()
	// This snippet has been automatically generated and should be regarded as a code template only.
	// It will require modifications to work:
	// - It may require correct/in-range values for request initialization.
	// - It may require specifying regional endpoints when creating the service client as shown in:
	//   https://pkg.go.dev/cloud.google.com/go#hdr-Client_Options
	c, err := fleetengine.NewTripClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &fleetenginepb.GetTripRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/cloud.google.com/go/maps/fleetengine/apiv1/fleetenginepb#GetTripRequest.
	}
	resp, err := c.GetTrip(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}

func ExampleTripClient_ReportBillableTrip() {
	ctx := context.Background()
	// This snippet has been automatically generated and should be regarded as a code template only.
	// It will require modifications to work:
	// - It may require correct/in-range values for request initialization.
	// - It may require specifying regional endpoints when creating the service client as shown in:
	//   https://pkg.go.dev/cloud.google.com/go#hdr-Client_Options
	c, err := fleetengine.NewTripClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &fleetenginepb.ReportBillableTripRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/cloud.google.com/go/maps/fleetengine/apiv1/fleetenginepb#ReportBillableTripRequest.
	}
	err = c.ReportBillableTrip(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
}

func ExampleTripClient_SearchTrips() {
	ctx := context.Background()
	// This snippet has been automatically generated and should be regarded as a code template only.
	// It will require modifications to work:
	// - It may require correct/in-range values for request initialization.
	// - It may require specifying regional endpoints when creating the service client as shown in:
	//   https://pkg.go.dev/cloud.google.com/go#hdr-Client_Options
	c, err := fleetengine.NewTripClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &fleetenginepb.SearchTripsRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/cloud.google.com/go/maps/fleetengine/apiv1/fleetenginepb#SearchTripsRequest.
	}
	it := c.SearchTrips(ctx, req)
	for {
		resp, err := it.Next()
		if err == iterator.Done {
			break
		}
		if err != nil {
			// TODO: Handle error.
		}
		// TODO: Use resp.
		_ = resp
	}
}

func ExampleTripClient_UpdateTrip() {
	ctx := context.Background()
	// This snippet has been automatically generated and should be regarded as a code template only.
	// It will require modifications to work:
	// - It may require correct/in-range values for request initialization.
	// - It may require specifying regional endpoints when creating the service client as shown in:
	//   https://pkg.go.dev/cloud.google.com/go#hdr-Client_Options
	c, err := fleetengine.NewTripClient(ctx)
	if err != nil {
		// TODO: Handle error.
	}
	defer c.Close()

	req := &fleetenginepb.UpdateTripRequest{
		// TODO: Fill request struct fields.
		// See https://pkg.go.dev/cloud.google.com/go/maps/fleetengine/apiv1/fleetenginepb#UpdateTripRequest.
	}
	resp, err := c.UpdateTrip(ctx, req)
	if err != nil {
		// TODO: Handle error.
	}
	// TODO: Use resp.
	_ = resp
}
